Name:		fence-virt
Version:	0.2.3
Release:	5%{?dist}
Summary:	A pluggable fencing framework for virtual machines
Group:		System Environment/Base
License:	GPLv2+
URL:		http://master.dl.sourceforge.net/project/fence-virt/fence-virt-%{version}.tar.gz
Source0:	%{name}-%{version}.tar.gz
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

ExclusiveArch:	i686 x86_64

BuildRequires:	corosynclib-devel clusterlib-devel libvirt-devel
BuildRequires:	openaislib-devel
BuildRequires:	qpid-cpp-client-devel qmf-devel
BuildRequires:	automake autoconf libxml2-devel nss-devel nspr-devel
BuildRequires:	flex bison libuuid-devel
Conflicts:	fence-agents < 3.0.5-2

# Patches
Patch0: bz720767-fix_incorrect_return_value_on_hash_mismatch.patch
Patch1: bz691200-fix_error_getting_status_from_libvirt_qpid_plugin.patch
Patch2: bz691200-2-convert_libvirt_qpid_plugin_to_qmfv2.patch
Patch3: bz691200-3-add_libvirt_qmf_support_to_the_libvirt_qpid_plugin.patch
Patch4: bz734687-don_t_reference_out_of_scope_temporary.patch


%description
Fencing agent for virtual machines.


%package -n fence-virtd
Summary:	Daemon which handles requests from fence-virt
Group:		System Environment/Base

%description -n fence-virtd
This package provides the host server framework, fence_virtd,
for fence_virt.  The fence_virtd host daemon is resposible for
processing fencing requests from virtual machines and routing
the requests to the appropriate physical machine for action.


%package -n fence-virtd-multicast
Summary:	Multicast listener for fence-virtd
Group:		System Environment/Base
Requires:	fence-virtd

%description -n fence-virtd-multicast
Provides multicast listener capability for fence-virtd.


%package -n fence-virtd-serial
Summary:	Serial VMChannel listener for fence-virtd
Group:		System Environment/Base
Requires:	libvirt >= 0.6.2
Requires:	fence-virtd

%description -n fence-virtd-serial
Provides serial VMChannel listener capability for fence-virtd.


%package -n fence-virtd-libvirt
Summary:	Libvirt backend for fence-virtd
Group:		System Environment/Base
Requires:	libvirt > 0.6.0
Requires:	fence-virtd

%description -n fence-virtd-libvirt
Provides fence_virtd with a connection to libvirt to fence
virtual machines.  Useful for running a cluster of virtual
machines on a desktop.


%package -n fence-virtd-libvirt-qpid
Summary:	Libvirt-qmf backend for fence-virtd
Group:		System Environment/Base
Requires:	libvirt > 0.6.0
Requires:	fence-virtd

%description -n fence-virtd-libvirt-qpid
Provides fence_virtd with a connection to libvirt-qmf to
fence virtual machines.  Libvirt-qmf provies a QMFv2 model
to track VMs across multiple hosts.  Note that this plugin
does not strictly require the presence of libvirt-qmf in
order to run; it is possible to talk to an external host.


%package -n fence-virtd-checkpoint
Summary:	Cluster+Libvirt backend for fence-virtd
Group:		System Environment/Base
Requires:	fence-virtd

%description -n fence-virtd-checkpoint
Provides fence_virtd with a connection to libvirt to fence
virtual machines.  Utilizes corosync's CPG framework to route
requests as well as the AIS Checkpoint API to store virtual
machine states across a cluster and make intelligent decisions
about whether a virtual machine is running.


%prep
%setup -q

%patch0 -p1 -b .bz720767.1
%patch1 -p1 -b .bz691200.1
%patch2 -p1 -b .bz691200.2
%patch3 -p1 -b .bz691200.3
%patch4 -p1 -b .bz734687.1

%build
./autogen.sh
%{configure}
make %{?_smp_mflags}


%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}
mkdir -p %{buildroot}/%{_sysconfdir}/rc.d/init.d
install -m 0755 fence_virtd.init %{buildroot}/%{_sysconfdir}/rc.d/init.d/fence_virtd

%post
# Update cluster schema (ignore return code)
ccs_update_schema > /dev/null 2>&1 ||:

%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc COPYING TODO README
%{_sbindir}/fence_virt
%{_sbindir}/fence_xvm
%{_mandir}/man8/fence_virt.*
%{_mandir}/man8/fence_xvm.*

%files -n fence-virtd
%defattr(-,root,root,-)
%{_sbindir}/fence_virtd
%{_sysconfdir}/rc.d/init.d/fence_virtd
%config(noreplace) %{_sysconfdir}/fence_virt.conf
%dir %{_libdir}/%{name}
%{_mandir}/man5/fence_virt.conf.*
%{_mandir}/man8/fence_virtd.*

%files -n fence-virtd-multicast
%defattr(-,root,root,-)
%{_libdir}/%{name}/multicast.so

%files -n fence-virtd-serial
%defattr(-,root,root,-)
%{_libdir}/%{name}/serial.so

%files -n fence-virtd-libvirt
%defattr(-,root,root,-)
%{_libdir}/%{name}/libvirt.so

%files -n fence-virtd-libvirt-qpid
%defattr(-,root,root,-)
%{_libdir}/%{name}/libvirt-qpid.so

%files -n fence-virtd-checkpoint
%defattr(-,root,root,-)
%{_libdir}/%{name}/checkpoint.so

%changelog
* Mon Sep 19 2011 Lon Hohberger <lon@users.sourceforge.net> - 0.2.3-5
- Don't reference out-of-scope temporary
  Resolves: rhbz#734687

* Tue Aug 16 2011 Lon Hohberger <lon@users.sourceforge.net> - 0.2.3-4
- Correct spec file and requirements.
  Related: rhbz#691200

* Thu Aug 11 2011 Lon Hohberger <lon@users.sourceforge.net> - 0.2.3-3
- Fix error getting status from libvirt-qpid plugin
  Convert libvirt-qpid plugin to QMFv2
  Add libvirt-qmf support to the libvirt-qpid plugin
  Resolves: rhbz#691200

* Mon Aug 08 2011 Lon Hohberger <lhh@redhat.com> - 0.2.3-2
- Fix incorrect return value on hash mismatch
  Resolves: rhbz#720767

* Fri Jul 08 2011 Lon Hohberger <lon@users.sourceforge.net> - 0.2.3-1
- Zap patch queue
- Add post call to fence-virt to integrate with cluster 3.1.4
- Rebase to latest upstream
- Provide 'domain' in metadata output for compatibility
- Fix input parsing to allow domain again
  Resolves: rhbz#719645

* Mon Mar 28 2011 Lon Hohberger <lon@users.sourceforge.net> - 0.2.1-8
- Rebuild against newer QMF libraries
  Related: rhbz#690582

* Wed Feb 02 2011 Lon Hohberger <lon@users.sourceforge.net> - 0.2.1-7
- Rebuild against newer QMF libraries
  Related: rhbz#631002

* Wed Feb 02 2011 Lon Hohberger <lon@users.sourceforge.net> - 0.2.1-6
- Fix man page references: fence_virtd.conf -> fence_virt.conf
  (fix_man_page_references_fence_virtd_conf_fence_virt_conf.patch)
  Resolves: rhbz#667170

* Fri Aug 6 2010 Lon Hohberger <lhh@redhat.com> - 0.2.1-5
- Rebuild against current qmf-client-cpp
  Resolves: rhbz#621889

* Wed May 12 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 0.2.1-4
- Do not build on ppc and ppc64.
  Resolves: rhbz#590986

* Wed Feb 24 2010 Lon Hohberger <lhh@redhat.com> 0.2.1-3
- Fix spec file due to qpid package renaming and architecture changes
- Don't build on s390 and s390x
- Resolves: rhbz#568003 rhbz#567744

* Wed Feb 10 2010 Lon Hohberger <lhh@redhat.com> 0.2.1-2
- Fix man page location
- Fix metadata output
- Fix arguments to be more consistent with other fencing
  agents
- Resolves: rhbz#561418 rhbz#563624 rhbz#563626

* Fri Jan 15 2010 Lon Hohberger <lhh@redhat.com> 0.2.1-1
- Update to latest upstream version
- Fix bug around status return codes for VMs which are 'off'

* Thu Jan 14 2010 Lon Hohberger <lhh@redhat.com> 0.2-1
- Update to latest upstream version
- Serial & VMChannel listener support
- Static permission map support
- Man pages
- Init script
- Various bugfixes

* Mon Nov 30 2009 Dennis Gregorovic <dgregor@redhat.com> - 0.1.2-1.1
- Rebuilt for RHEL 6

* Mon Sep 21 2009 Lon Hohberger <lhh@redhat.com> 0.1.2-1
- Update to latest upstream version
- Fix build issue on i686

* Mon Sep 21 2009 Lon Hohberger <lhh@redhat.com> 0.1.1-1
- Update to latest upstream version
- Clean up spec file

* Mon Sep 21 2009 Lon Hohberger <lhh@redhat.com> 0.1-2
- Spec file cleanup

* Thu Sep 17 2009 Lon Hohberger <lhh@redhat.com> 0.1-1
- Initial build for rawhide
